; interrupt service routines

ADCROUTINE:											; ADC conversion complete
		push	Temp
		in		Temp, SREG
		push	Temp
		push	Temp2
		push	Temp3
		push	Temp4
		lds		Temp4, MeanValH
		lds		Temp3, MeanValL						; do a mean value calculation
		mov		Temp2, Temp4
		mov		Temp, Temp3
		lsr		Temp2
		ror		Temp
		lsr		Temp2
		ror		Temp
		lsr		Temp2
		ror		Temp
		lsr		Temp2
		ror		Temp
		lsr		Temp2
		ror		Temp
		sub		Temp3, Temp
		sbc		Temp4, Temp2
		sts		AnaResH, Temp2
		sts		AnaResL, Temp
		in		Temp, ADCL
		in		Temp2, ADCH
		andi	Temp2, 0b00000011						; mask out all non adc bits
		add		Temp3, Temp
		adc		Temp4, Temp2
		sts		MeanValH, Temp4
		sts		MeanValL, Temp3
		pop		Temp4
		pop		Temp3
		pop		Temp2
		pop		Temp
		out		SREG, Temp
		pop		Temp
		reti

TIM0OVFROUTINE:										; timer 0 overflow
		push	Temp
		in		Temp, SREG
		dec		counter
		brne	T0OVF_OUT
		ldi		counter, countervalue
		ori		Status, 1<<ACT_BIT
 T0OVF_OUT:
		out		SREG, Temp
		pop		Temp
		reti

;TIM0COMPBROUTINE:
;		reti