; main file of the project

.include "tn13adef.inc"									; processor definition
.include "readme.inc"									; description of the program
.include "variables.inc"								; definition of variables
.include "config.inc"									; fixed configuration values
.include "pinconf.inc"                                  ; GPIO settings
.include "tiny13aorg.inc"								; interrupt vectors

.include "main.inc"										; main program
.include "interruptroutines.inc"						; interrupt service routines
.include "tiny13aadc.inc"								; adc primitive routines
.include "tiny13atimers.inc"							; include timer primitive routines
.include "tiny13aeep.inc"								; include eeprom read and write routines
.include "subroutines.inc"								; subroutine calls of the main program

.eseg													; default eeprom values
.org 0x00
	.db	0xAC, 0x0D, 0xFF								; PWMMax, LinCoeff, MaxPWM2